#include <iostream>
#include <string>

using namespace std;

int main()
{
    int n, i;
    cin>>n;
    int o, a, b, ab;
    cin>>o>>a>>b>>ab;
    int mennyi[n];
    string mibol[n];
    int e[n][4]={0};
    for(i=0;i<n;i++)
    {
        cin>>mibol[i]>>mennyi[i];
    }
    for(i=0;i<n;i++)
    {
        if (mibol[i]=="O")
        {
            o-=mennyi[i];
            if (o<0)
            {
                cout<<"nemoguce";
                return 0;
            }
            else
            {
                e[i][0]=mennyi[i];
            }
        }
    }
    for(i=0;i<n;i++)
    {
        if(mibol[i]=="A")
        {
            if (a>=mennyi[i])
            {
                a-=mennyi[i];
                e[i][1]=mennyi[i];
            }
            else
            {
                mennyi[i]-=a;
                e[i][1]=a;
                a=0;
                if (o<mennyi[i])
                {
                    cout<<"nemoguce";
                    return 0;
                }
                else
                {
                    o-=mennyi[i];
                    e[i][0]=mennyi[i];
                }
            }
        }

        if(mibol[i]=="B")
        {
            if (b>=mennyi[i])
            {
                b-=mennyi[i];
                e[i][2]=mennyi[i];
            }
            else
            {
                mennyi[i]-=b;
                e[i][2]=b;
                b=0;
                if (o<mennyi[i])
                {
                    cout<<"nemoguce";
                    return 0;
                }
                else
                {
                    o-=mennyi[i];
                    e[i][0]=mennyi[i];
                }
            }
        }
    }

    for(i=0;i<n;i++)
    {
        if(mibol[i]=="AB")
        {
            if(o+a+b+ab<mennyi[i])
            {
                cout<<"nemoguce";
                return 0;
            }
            else
            {
                if (o>=mennyi[i])
                {
                    o-=mennyi[i];
                    e[i][0]=mennyi[i];
                }
                else
                {
                    mennyi[i]-=o;
                    e[i][0]=o;
                    o=0;
                    if (a>=mennyi[i])
                    {
                        a-=mennyi[i];
                        e[i][1]=mennyi[i];
                    }
                    else
                    {
                        mennyi[i]-=a;
                        e[i][1]=a;
                        a=0;
                        if (b>=mennyi[i])
                        {
                            b-=mennyi[i];
                            e[i][2]=mennyi[i];
                        }
                        else
                        {
                            mennyi[i]-=b;
                            e[i][2]=b;
                            b=0;
                            ab-=mennyi[i];
                            e[i][3]=mennyi[i];
                        }
                    }
                }
            }
        }
    }
    int j;
    cout<<"moguce"<<endl;
    for(i=0;i<n;i++)
    {
        for(j=0;j<4;j++)
            cout<<e[i][j]<<" ";
        cout<<endl;
    }



    return 0;
}